<template>
  <div id="prueba">
      <h1>Prueba técnica</h1>
      <div>
        <form action class="form">
          <label class="form-label" for="#search">Buscar</label>
          <input v-model="search" style="text-transform: lowercase;" class="form-input" type="text" id="searchInput" required @keyup="buscar()">
        </form>
      </div>
      <div id="result" v-if="resultDiv">
        <div class="row">
          <div class="table-responsive col-md-12" v-if="listPlace.length > 0">
            <h3>Lugares listados</h3>
            <table class="table" >
              <tbody>
                <tr>
                  <th>category</th>
                  <th>display_name</th>
                  <th>icon</th>
                  <th>importance</th>
                  <th>lat</th>
                  <th>licence</th>
                  <th>lon</th>
                  <th>osm_type</th>
                  <th>place_rank</th>
                </tr>
                <tr v-for="l in listPlace" :key="l.place_id">
                  <td>{{l.category}}</td>
                  <td>{{l.display_name}}</td>
                  <td>
                    <img :src="l.icon">
                  </td>
                  <td>{{l.importance}}</td>
                  <td>{{l.lat}}</td>
                  <td>{{l.licence}}</td>
                  <td>{{l.lon}}</td>
                  <td>{{l.osm_type}}</td>
                  <td>{{l.place_rank}}</td>
                </tr>
              </tbody>
            </table>
          </div>
          <div v-else class="col-md-12">
            <p>No se han encontrado resultados</p>
          </div>
        </div>
      </div>
  </div>
</template>

<script>
export default {
  name: 'Prueba',
  data: () => ({
    search: "",
    listPlace: [],
    interval: null,
    resultDiv: false
  }),
  methods: {
    SortArray(x, y){
      if (x.display_name < y.display_name) {return -1;}
      if (x.display_name > y.display_name) {return 1;}
      return 0;
    },
    buscar() {
      clearTimeout(this.interval)
      var self = this
      self.search = self.search.replace(/[^\w\s]/gi, "");
      self.search = self.search.toLowerCase()
      this.interval = setTimeout(function () {
        self.fetch()
      }, 300)
      //this.fetch()
    },
    async fetch() {
      var self = this
      if(self.search.length > 2) {
        self.listPlace = await fetch(
          'https://nominatim.openstreetmap.org/search.php?q='+ self.search + '&format=jsonv2'
        ).then(res => res.json())
        self.resultDiv = true
        self.listPlace.sort(self.SortArray());
        console.log(self.listPlace)
      } else {
        self.resultDiv = false
      }
    }
  }
}
</script>
